#include <stdio.h>
#include "type.h"
#include "mem.h"

extern int verbose;
#define	PRINTF	if (verbose) printf

#define	rPC	32
#define	CPR0	35
#define	SR		regs[CPR0+12]
#define	CAUSE	regs[CPR0+13]
#define	EPC		regs[CPR0+14]

	register UINT32 *regs asm("%esi");

void rfe(void)
{
//	register UINT32 *regs asm("%esi");
	SR = (SR & ~0xf)| ((SR>>2)&0xf);
	PRINTF("rfe:%x\n",SR);
}

UINT32 exception(int cd,UINT32 pc)
{
//	register UINT32 *regs asm("%esi");
	PRINTF("Exception:%x %x\n",cd,pc);
	EPC=pc;
	//CAUSE = (CAUSE & ~0x3c) | cd;
	CAUSE = cd;
	SR = (SR & ~0x3f)| ((SR<<2)&0x3f);
	return jmppc(0x80000080);
}

extern UINT32 reg[];
void compile_go(void)
{
//	register UINT32 *regs asm("%esi");
	void (*func)();
	func = jmppc(reg[rPC]);
	regs = &reg;
	func();
}
